/* 
 * Proview   $Id: twolist.h,v 1.2 2005-09-01 14:57:48 claes Exp $
 * Copyright (C) 2005 SSAB Oxelsund AB.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with the program, if not, write to the Free Software 
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Specifikation av tvvgslista -- twolist.h */

#ifndef TWOLISTH
#define TWOLISTH

#ifndef rt_elog_h
#include "rt_elog.h"
#endif

typedef sKey datatyp;       /* Exempelvis */

typedef
struct twolink
{
   enum {head, lank} kind;
   struct twolink *befo, *next;
   datatyp data;
} headtyp, linktyp;

void newhead(headtyp **hpp);
/* Skapar en ny tom lista */

void newlink(linktyp **lpp);
/* Skapar en ny tom lnk */

void putlink(datatyp d, linktyp *lp);
/* Stter in data i en lnk */

datatyp getlink(linktyp *lp);
/* Returnerar data frn lnk */

void inlast(linktyp *lp, headtyp *hp);
/* Stter in lnken sist i listan */

void infirst(linktyp *lp, headtyp *hp);
/* Stter in lnken frst i listan */

void inpred(linktyp *lp, linktyp *ep);
/* Stter in frsta lnken fre den andra */

void insucc(linktyp *lp, linktyp *ep);
/* Stter in frsta lnken efter den andra */

void insort(linktyp *lp, headtyp *hp, int (*is_less)(datatyp d1, datatyp d2));
/* Stter in lnken sorterad enligt is_less */

linktyp *firstlink(headtyp *hp);
/* Returnerar pekare till frsta lnken i listan */

linktyp *lastlink(headtyp *hp);
/* Returnerar pekare till sista lnken i listan */

linktyp *predlink(linktyp *lp);
/* Returnerar pekare till lnken fre */

linktyp *succlink(linktyp *lp);
/* Returnerar pekare till lnken efter */

int is_link(linktyp *lp);
/* Returnerar 1 om lnk annars 0 */

int empty(headtyp *hp);
/* Returnerar 1 om listan tom annars 0 */

int nrlinks(headtyp *hp);
/* Returnerar antalet lnkar i listan */

void outlist(linktyp *lp);
/* Tar bort lnken frn listan */

void elimlink(linktyp **lpp);
/* Tar bort, avallokerar och NULL-stller lnken */

void clearhead(headtyp *hp);
/* Tar bort alla lnkar frn listan */

void elimhead(headtyp **hpp);
/* Eliminerar och NULL-stller listan */

#endif
